if select(2, UnitClass("player")) ~= "DRUID" then return end -- non druids has no real use for this

local buttons = {}


local function onEnter(self, motion)
	if GetCVarBool("UberTooltips") then
		GameTooltip_SetDefaultAnchor(GameTooltip, self)
	else
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	end
	GameTooltip:SetShapeshift(self:GetID())
end


local function createButton(index)
	local button = CreateFrame("Button", nil, _G["ShapeshiftButton"..index], "SecureActionButtonTemplate")
	button:RegisterForClicks("AnyUp")
	button:SetAllPoints()
	button:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress")
	button:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square")
	button:SetAttribute("type", "spell")
	button:SetScript("OnEnter", onEnter)
	button:SetScript("OnLeave", GameTooltip_Hide)
	buttons[index] = button
	return button
end


local addon = CreateFrame("Frame")
addon:RegisterEvent("PLAYER_LOGIN")
addon:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
addon:SetScript("OnEvent", function(self, event)
	for i = 1, GetNumShapeshiftForms() do
		local button = buttons[i] or createButton(i)
		local _, name = GetShapeshiftFormInfo(i)
		button:SetID(i)
		button:SetAttribute("spell1", name)
		button:SetAttribute("spell2", "!"..name)
	end
end)